#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const USAGE = `Wrong command has been detected. Use like below:

npx nestia [command] [options?]

  1. npx nestia start <directory>
  2. npx nestia template <directory>
  3. npx nestia setup
  4. npx nestia dependencies
  5. npx nestia init
  6. npx nestia sdk
  7. npx nestia swagger
  8. npx nestia e2e
`;
function halt(desc) {
    console.error(desc);
    process.exit(-1);
}
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const type = process.argv[2];
        const argv = process.argv.slice(3);
        if (type === "start") {
            yield (yield Promise.resolve().then(() => __importStar(require("./NestiaStarter")))).NestiaStarter.clone((msg) => halt(msg !== null && msg !== void 0 ? msg : USAGE))(argv);
        }
        else if (type === "template") {
            yield (yield Promise.resolve().then(() => __importStar(require("./NestiaTemplate")))).NestiaTemplate.clone((msg) => halt(msg !== null && msg !== void 0 ? msg : USAGE))(argv);
        }
        else if (type === "setup") {
            try {
                yield Promise.resolve().then(() => __importStar(require("comment-json")));
                yield Promise.resolve().then(() => __importStar(require("inquirer")));
                yield Promise.resolve().then(() => __importStar(require("commander")));
            }
            catch (_a) {
                halt(`nestia has not been installed. Run "npm i -D nestia" before.`);
            }
            yield (yield Promise.resolve().then(() => __importStar(require("./NestiaSetupWizard")))).NestiaSetupWizard.setup();
        }
        else if (type === "dependencies" ||
            type === "init" ||
            type === "sdk" ||
            type === "swagger" ||
            type === "e2e") {
            try {
                require.resolve("@nestia/sdk/lib/executable/sdk");
            }
            catch (_b) {
                halt(`@nestia/sdk has not been installed. Run "npx nestia setup" before.`);
            }
            yield Promise.resolve().then(() => __importStar(require("@nestia/sdk/lib/executable/sdk")));
        }
        else
            halt(USAGE);
    });
}
main().catch((exp) => {
    console.log(exp.message);
    process.exit(-1);
});
//# sourceMappingURL=index.js.map